"use strict";

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var eventsMap = exports.eventsMap = {
  clipboard: {
    eventNames: ["copy", "cut", "paste"],
    props: ["clipboardData"]
  },
  composition: {
    eventNames: ["compositionEnd", "compositionStart", "compositionUpdate"],
    props: ["data"]
  },
  keyboard: {
    eventNames: ["keyDown", "keyUp", "keyPress"],
    props: ["altKey", "charCode", "ctrlKey", "getModifierState"]
  },
  focus: { eventNames: ["focus", "blur"], props: ["relatedTarget"] },
  form: {
    eventNames: ["change", "input", "invalid", "submit"],
    props: []
  },
  mouse: {
    eventNames: ["click", "contextMenu", "doubleClick", "drag", "dragEnd", "dragEnter", "dragExit", "dragLeave", "dragOver", "dragStart", "drop", "mouseDown", "mouseEnter", "mouseLeave",
    // "mouseMove",
    // "mouseOut",
    // "mouseOver",
    "mouseUp"],
    props: ["altKey", "button", "buttons", "clientX", "clientY", "ctrlKey", "getModifierState", "metaKey", "pageX", "pageY", "relatedTarget", "screenX", "screenY", "shiftKey"]
  },
  selection: { eventNames: ["select"], props: [] },
  touch: {
    eventNames: ["touchCancel", "touchEnd", "touchMove", "touchStart"],
    props: ["altKey", "changedTouches", "ctrlKey", "getModifierState", "metaKey", "shiftKey", "targetTouches", "touches"]
  },
  ui: { eventNames: ["scroll"], props: ["detail", "view"] },
  wheel: {
    eventNames: ["wheel"],
    props: ["deltaMode", "deltaX", "deltaY", "deltaX"]
  },
  media: {
    eventNames: ["abort", "canPlay", "canPlayThrough", "durationChange", "emptied", "encrypted", "ended", "error", "loadedData", "loadedMetadata", "loadStart", "pause", "play", "playing", "progress", "rateChange", "seeked", "seeking", "stalled", "suspend", "timeUpdate", "volumeChange", "waiting"],
    props: []
  },
  image: { eventNames: ["load", "error"], props: [] },
  animation: {
    eventNames: ["animationStart", "animationEnd", "animationIteration"],
    props: ["animationName", "pseudoElement", "elapsedTime"]
  },
  transition: {
    eventNames: ["transitionEnd"],
    props: ["propertyName", "pseudoElement", "elapsedTime"]
  },
  others: { eventNames: ["toggle"], props: [] }
};

var allEvents = exports.allEvents = Object.entries(eventsMap).map(function (_ref) {
  var eventType = _ref[0],
      eventDetails = _ref[1];
  return eventDetails;
}).reduce(function (acc, e) {
  return _extends({}, acc, e.eventNames.reduce(function (acc2, eventName) {
    var _extends2;

    return _extends({}, acc2, (_extends2 = {}, _extends2[eventName] = e.props, _extends2));
  }, {}));
}, {});

var allEventNames = exports.allEventNames = Object.keys(allEvents);