"use strict";

exports.__esModule = true;
exports.TestViewerContainer = exports.TestViewer = undefined;

var _reactCopyToClipboard = require("react-copy-to-clipboard");

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactDraggable = require("react-draggable");

var _reactDraggable2 = _interopRequireDefault(_reactDraggable);

var _portal = require("./portal");

var _portal2 = _interopRequireDefault(_portal);

var _reactCollapsible = require("react-collapsible");

var _reactCollapsible2 = _interopRequireDefault(_reactCollapsible);

var _simple_button = require("./simple_button");

var _simple_button2 = _interopRequireDefault(_simple_button);

var _prismLight = require("react-syntax-highlighter/prism-light");

var _prismLight2 = _interopRequireDefault(_prismLight);

var _jsx = require("react-syntax-highlighter/languages/prism/jsx");

var _jsx2 = _interopRequireDefault(_jsx);

var _prism = require("react-syntax-highlighter/styles/prism/prism");

var _prism2 = _interopRequireDefault(_prism);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

(0, _prismLight.registerLanguage)("jsx", _jsx2.default);

var CollapsibleHeader = function CollapsibleHeader(props) {
  return _react2.default.createElement(
    "div",
    {
      className: "drag-handle",
      style: {
        display: "flex",
        justifyContent: "space-between",
        backgroundColor: "#EED369",
        color: "#31363C",
        padding: 10
      }
    },
    _react2.default.createElement(
      "h4",
      null,
      "Automated test for ",
      props.componentName
    ),
    _react2.default.createElement(
      "div",
      null,
      ">"
    )
  );
};

var TestViewer = exports.TestViewer = function (_React$Component) {
  _inherits(TestViewer, _React$Component);

  function TestViewer() {
    var _temp, _this, _ret;

    _classCallCheck(this, TestViewer);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.state = {
      copiedToClipboard: false
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  TestViewer.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    if (nextProps.testString !== this.props.testString) {
      this.setState({ copiedToClipboard: false });
    }
  };

  TestViewer.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        testString = _props.testString,
        onGetTestClick = _props.onGetTestClick,
        withImports = _props.withImports;


    return _react2.default.createElement(
      "div",
      { style: { padding: 15, backgroundColor: "#083045", color: "white" } },
      testString ? _react2.default.createElement(
        "div",
        null,
        _react2.default.createElement(
          "div",
          null,
          _react2.default.createElement(
            "div",
            null,
            _react2.default.createElement(
              _reactCopyToClipboard.CopyToClipboard,
              {
                text: testString,
                onCopy: function onCopy() {
                  return _this2.setState({ copiedToClipboard: true });
                }
              },
              _react2.default.createElement(
                _simple_button2.default,
                null,
                "Copy to clipboard"
              )
            ),
            this.state.copiedToClipboard ? _react2.default.createElement(
              "span",
              { style: { color: "red", marginLeft: 10 } },
              "Copied"
            ) : null,
            _react2.default.createElement("input", {
              type: "checkbox",
              checked: this.props.withImports,
              value: "With exports",
              style: { marginLeft: 10 },
              onChange: this.props.onWithImportsChange
            }),
            " ",
            "With exports"
          )
        ),
        _react2.default.createElement(
          _prismLight2.default,
          { language: "javascript", style: _prism2.default },
          testString
        )
      ) : _react2.default.createElement(
        "div",
        null,
        _react2.default.createElement(
          "p",
          null,
          "No tests yet. Click on the button to generate a test."
        ),
        _react2.default.createElement(
          _simple_button2.default,
          { onClick: onGetTestClick },
          "Get test"
        )
      )
    );
  };

  return TestViewer;
}(_react2.default.Component);

var TestViewerContainer = exports.TestViewerContainer = function TestViewerContainer(props) {
  var componentName = props.componentName,
      onTestNameChange = props.onTestNameChange,
      testName = props.testName,
      onStartTestGeneration = props.onStartTestGeneration,
      onStopTestGeneration = props.onStopTestGeneration,
      onExcludeClick = props.onExcludeClick,
      excludedEvents = props.excludedEvents,
      onGeneratorChange = props.onGeneratorChange,
      generator = props.generator;


  return _react2.default.createElement(
    _portal2.default,
    null,
    _react2.default.createElement(
      _reactDraggable2.default,
      { defaultPosition: { x: 0, y: 0 }, handle: ".drag-handle" },
      _react2.default.createElement(
        "div",
        {
          style: { position: "absolute", right: 30, top: 30, minWidth: 500 }
        },
        _react2.default.createElement(
          _reactCollapsible2.default,
          {
            trigger: _react2.default.createElement(CollapsibleHeader, { componentName: componentName }),
            transitionTime: 100,
            open: true
          },
          _react2.default.createElement(
            "div",
            { style: { backgroundColor: "#083045" } },
            _react2.default.createElement(
              "div",
              {
                style: {
                  display: "flex",
                  justifyContent: "flex-end",
                  padding: 10,

                  color: "white",
                  alignItems: "center"
                }
              },
              _react2.default.createElement(
                "label",
                { style: { marginRight: 10, fontSize: "1.2em" } },
                "Test Name"
              ),
              _react2.default.createElement("input", {
                onChange: onTestNameChange,
                value: testName,
                placeholder: "Name of your test",
                style: {
                  marginRight: 10,
                  padding: "0.3em 0.6em",
                  fontSize: "1.2em",
                  maxWidth: 200
                }
              }),
              _react2.default.createElement(
                _simple_button2.default,
                {
                  type: "primary",
                  style: { marginRight: 10 },
                  onClick: onStartTestGeneration
                },
                "Start from now"
              ),
              _react2.default.createElement(
                _simple_button2.default,
                { type: "primary", onClick: onStopTestGeneration },
                "Get test"
              )
            ),
            _react2.default.createElement(
              "div",
              {
                style: {
                  display: "flex",
                  alignItems: "center",
                  paddingLeft: 10
                }
              },
              _react2.default.createElement(
                "a",
                {
                  style: {
                    cursor: "pointer",
                    color: "white",
                    textDecoration: "underline"
                  },
                  onClick: onExcludeClick
                },
                "Exclude events"
              ),
              _react2.default.createElement(
                "span",
                {
                  style: { marginLeft: 10, color: "red" },
                  title: excludedEvents.join(" ")
                },
                excludedEvents.length,
                " events excluded"
              )
            ),
            _react2.default.createElement(
              "div",
              { style: { paddingLeft: 10, marginTop: 10 } },
              _react2.default.createElement(
                "select",
                {
                  name: "test_generator",
                  value: generator,
                  onChange: onGeneratorChange
                },
                _react2.default.createElement(
                  "option",
                  { value: "enzyme" },
                  "Enzyme"
                ),
                _react2.default.createElement(
                  "option",
                  { value: "cypress" },
                  "Cypress"
                )
              ),
              generator === "cypress" && _react2.default.createElement(
                "span",
                {
                  style: { marginLeft: 10, fontSize: "1.2em", color: "red" }
                },
                "** EXPERIMENTAL - BAREBONES **"
              )
            ),
            _react2.default.createElement(TestViewer, props)
          )
        )
      )
    )
  );
};